/*-
 * Copyright (C) @BABOLO  2005 Nov 2
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: ref.cc,v 1.2 2005/11/11 16:10:59 babolo Exp $
 */

/***************************************************/
/*     codex.ref()    */
/***************************************************/

static char *
eqref(ISO8583_Pack *pack, int fno) {
    int len = pack->package->fld[fno].len;
    u_char *ref = pack->refo[fno];
    char *s;

    s = malloc(len + 1);
    if  (s) {
        memmove(s, ref, len);
        *(s + len) = '\0';
    }
    return(s);
}

static char *
llref(ISO8583_Pack *pack, int fno) {
    char *s;
    u_int32_t l;
    u_char *ref = pack->refo[fno];

    l = lv(0, 2, ref++);
    s = malloc(l + 1);
    if  (s) {
        memmove(s, ref, l);
        *(s + l) = '\0';
    }
    return(s);
}

static char *
dadim(time_t t) {
    struct tm tm;
    char *c;

    bzero(&tm, sizeof(struct tm));
    gmtime_r(&t, &tm);
    asprintf( &c, "%4u-%02u-%02u %02u:%02u:%02u"
            , tm.tm_year + 1900, tm.tm_mon + 1, tm.tm_mday, tm.tm_hour, tm.tm_min, tm.tm_sec
            );
    return(c);
}

static char *
dim(ISO8583_Pack *pack, int fno) {
    time_t t;
    t = expnd(pack, fno, 14 - pack->package->fld[fno].len);
    return(dadim(t));
}

static char *
dad(ISO8583_Pack *pack, int fno) {
    time_t t;
    t = expnd(pack, fno, 2);
    return(dadim(t));
}

static char *
dadt(ISO8583_Pack *pack, int fno) {
    time_t t;
    t = expnd(pack, fno, 8 - pack->package->fld[fno].len);
    return(dadim(t));
}
